{
   muu TrueColor library for TMT Pascal - Clear example
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

USES mArea,mFormat,mSurface,mConsole,mTarga,mc_VESA,mc_Wrap,Nova,CRT,Error,Memory,HTimer;

//{$DEFINE debug_wrapper}  // enable this ONLY for debugging

    // our Console, clear the variables for neatness
VAR testconsole:    Console := NIL;
    dimer:      Timer := NIL;
    frames:     dword := 0;

    // set textmode
PROCEDURE set_textmode; assembler;
ASM
  mov  ax,  $03
  int  $10
END;

        // -------------- START OF MAIN CODE ----------------

begin
    // We will use the VBEConsole to display the image, therefore we overload
    // the testconsole type when creating it (creating means allocating)
    // (if debug_wrapper is defined, wrap VBEConsole to wrapper
  {$IFNDEF debug_wrapper}
    new(VBEConsole(testconsole),Create);
  {$ELSE}
    new(TTYConsole(testconsole),Create);
    DECLARE VAR deb: Console;
    BEGIN
      new(VBEConsole(deb),Create);
      testconsole^.Wrap(deb);
    END;
  {$ENDIF}

    // read options into Console, which will be used instead of the default
    // values if specified (here we load options from "mtc.cfg")
  testconsole^.getOptions(mtc_option_file);

    // options are set, and we can safely proceed opening our Console.
  testconsole^.Open('Clear example',0,0,Format(Unknown));

    // check if an error occurred when opening, and exit with error if so
  IF (testconsole^.Error) THEN
    fail('Failed to create console');

  new(dimer,Create);
  dimer^.Start;

    // clear Area of a Surface and copy the Area to the Console (fastest)
  DECLARE VAR l,t,r,b:  dword;
  REPEAT
        // calculate Area coordinates for a rectangle.
    l := random(testconsole^.Info.Width);
    t := random(testconsole^.Info.Height);
    r := random(testconsole^.Info.Width);
    b := random(testconsole^.Info.Height);

    testconsole^.Clear(Area(l,t,r,b),random($FFFFFFFF));

    // this _MUST_ be called to make sure the Console updates the screen
    testconsole^.Update;
    frames +:= 1;
  UNTIL (keypressed);
  dimer^.Stop;

    // clear keyboard buffer
  WHILE (keypressed) DO readkey;

    // close Console and free that one, too
  testconsole^.Close;
  dispose(testconsole,Destroy);

    // set textmode
  set_textmode;

  writeln('Frames per second: ', frames/(dimer^.Elapsed/1000):0:3);writeln;

  writeln('muu TrueColor library for TMT Pascal - Clear example');
  writeln('Copyright (C) 1999 Tor Arne Gustad (anden@online.no)');
end.
