{
   muu Library for TMT Pascal - Dither matrix setup
   Original C code Copyright (C) 1998 The Rasterman

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

PROCEDURE Dither_SetupMatrices;
  VAR i,x,y:    integer := 0;
  FOR y := 0 TO 3 DO
    FOR x := 0 TO 3 DO
      FOR i := 0 TO 255 DO
      BEGIN
        IF ((DitherMatrix_44[x,y] < (i AND $07)) AND (i < (256 - 8))) THEN
        BEGIN
          DitherTab_r565_44[x,y,i] := ((i + 8) AND $F8) SHL 8;
          DitherTab_r332_44[x,y,i] := ((i + 8) AND $E0);
        END ELSE
        BEGIN
          DitherTab_r565_44[x,y,i] := (i AND $F8) SHL 8;
          DitherTab_r332_44[x,y,i] := (i AND $E0);
        END;

        IF ((DitherMatrix_44[x,y] < ((i AND $03) SHL 1)) AND (i < (256 - 4))) THEN
        BEGIN
//          DitherTab_g565_44[x,y,i] := (((i + 4) AND $FC) SHL 8) SHR 5;
          DitherTab_g565_44[x,y,i] := (((i + 4) AND $FC) SHL 3);
          DitherTab_g332_44[x,y,i] := ((i + 4) AND $E0) SHR 3;
        END ELSE
        BEGIN
//          DitherTab_g565_44[x,y,i] := ((i AND $FC) SHL 8) SHR 5;
          DitherTab_g565_44[x,y,i] := ((i AND $FC) SHL 3);
          DitherTab_g332_44[x,y,i] := (i AND $E0) SHR 3;
        END;

        IF ((DitherMatrix_44[x,y] < (i AND $07)) AND (i < (256 - 8))) THEN
        BEGIN
//          DitherTab_b565_44[x,y,i] := (((i + 8) AND $F8) SHL 16) SHR 19;
          DitherTab_b565_44[x,y,i] := (((i + 8) AND $F8) SHR 3);
          DitherTab_b332_44[x,y,i] := ((i + 8) SHR 6) AND $03;
        END ELSE
        BEGIN
//          DitherTab_b565_44[x,y,i] := ((i AND $F8) SHL 16) SHR 19;
          DitherTab_b565_44[x,y,i] := ((i AND $F8) SHR 3);
          DitherTab_b332_44[x,y,i] := (i SHR 6) AND $03;
        END;
      END;
