{
   muu TrueColor library for TMT Pascal - Clip unit
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.       
}

UNIT mClip;

INTERFACE
{$R-,I+,Q-}

USES mArea;

    // returns true if an Area is invalid
FUNCTION Null_area(m_area:Area): boolean;
    // returns true if an Area has unsorted coordinates
FUNCTION Unsorted_area(m_area:Area): boolean;
    // returns true if exact match
FUNCTION Equal_area(m_one,m_two:Area): boolean;

    // clip Area coordinates within given rectangle
FUNCTION Clip_rectangle(m_area:Area;m_rect:Area): Area;

  OVERLOAD Null = Null_area;
  OVERLOAD Unsorted = Unsorted_area;
  OVERLOAD Equal = Equal_area;
  OVERLOAD Clip = Clip_rectangle;

  OVERLOAD = = Equal_area;

IMPLEMENTATION

FUNCTION Null_area;
  IF (m_area.Left = m_area.Right) OR
     (m_area.Top = m_area.Bottom) THEN
    result := true
  ELSE
    result := false;

FUNCTION Unsorted_area;
  result := boolean(m_area.Left > m_area.Right) OR 
            boolean(m_area.Top > m_area.Bottom);

FUNCTION Equal_area;
  result := boolean(m_one.Left = m_two.Left) AND
            boolean(m_one.Right = m_two.Right) AND
            boolean(m_one.Top = m_two.Top) AND
            boolean(m_one.Bottom = m_two.Bottom);

FUNCTION Clip_rectangle;
BEGIN
    // clip min.values
  IF (m_area.Left < m_rect.Left) THEN
    m_area.Left := m_rect.Left;
  IF (m_area.Top < m_rect.Top) THEN
    m_area.Top := m_rect.Top;
  IF (m_area.Right < m_rect.Left) THEN
    m_area.Right := m_rect.Left;
  IF (m_area.Bottom < m_rect.Top) THEN
    m_area.Bottom := m_rect.Top;

    // clip max.values
  IF (m_area.Right > m_rect.Right) THEN
    m_area.Right := m_rect.Right;
  IF (m_area.Bottom > m_rect.Bottom) THEN
    m_area.Bottom := m_rect.Bottom;
  IF (m_area.Left  > m_rect.Right) THEN
    m_area.Left := m_rect.Right;
  IF (m_area.Top > m_rect.Bottom) THEN
    m_area.Top := m_rect.Bottom;

    // check, sort and return
  IF Null(m_area) THEN 
    result := Area(0,0,0,0)
  ELSE
    result := Area(m_area);
END;


end.
