{
   muu TrueColor library for TMT Pascal - VESA VBE type definitions
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

UNIT VBETypes;

INTERFACE
{$R-,I+,Q-}

    // VESA information record
TYPE VBE_VESAinformation  = ^VBE_VESAinformationT;
     VBE_VESAinformationT = RECORD
                  VBESignature:         ARRAY[0..3] OF char;
                  VBEVersion:           word;
                  
                  OEMStringPTR_OFS:     word;
                  OEMStringPTR_SEG:     word;
                  
                  Capabilities:         dword;

                  VideoModePTR_OFS:     word;
                  VideoModePTR_SEG:     word;

                  TotalMemory:          word;
                  OEMSoftwareRev:       word;

                  OEMVendorNamePTR_OFS: word;
                  OEMVendorNamePTR_SEG: word;
                  
                  OEMProductNamePTR_OFS:word;
                  OEMProductNamePTR_SEG:word;
                  
                  OEMProductRevPTR_OFS: word;
                  OEMProductRevPTR_SEG: word;
                  
                  Reserved:             ARRAY[0..221] OF byte;
                  OEMdata:              ARRAY[0..255] OF byte;
                END;

    // VESA mode information record
TYPE VBE_modeinformation  = ^VBE_modeinformationT;
     VBE_modeinformationT = RECORD
                  ModeAttributes:       word;
                  WinAAttributes:       byte;
                  WinBAttributes:       byte;
                  WinGranularity:       word;
                  WinSize:              word;
                  WinASegment:          word;
                  WinBSegment:          word;
                  WinFuncPTR:           dword;
                  BytesPerScanLine:     word;
                  XResolution:          word;
                  YResolution:          word;
                  XCharSize:            byte;
                  YCharSize:            byte;
                  NumberOfPlanes:       byte;
                  BitsPerPixel:         byte;
                  NumberOfBanks:        byte;
                  MemoryModel:          byte;
                  BankSize:             byte;
                  NumberOfImagePages:   byte;
                  Reserved:             byte;   // ...for page function
                  RedMaskSize:          byte;
                  RedFieldPosition:     byte;
                  GreenMaskSize:        byte;
                  GreenFieldPosition:   byte;
                  BlueMaskSize:         byte;
                  BlueFieldPosition:    byte;
                  RsvdMaskSize:         byte;
                  RsvdFieldPosition:    byte;
                  DirectColorModeInfo:  byte;
                  PhysBasePTR:          dword;
                  OffScreenMemOffset:   dword;
                  OffScreenMemSize:     word;
                  Reserved2:            ARRAY[0..205] OF byte;
                END;

    // VESA palette types (red,green,blue,alpha)
TYPE _colorchannels = (rchn,gchn,bchn,achn);
TYPE VBE_VESApalette =  ^VBE_VESApaletteT;
     VBE_VESApaletteT = ARRAY[0..255,_colorchannels] OF BYTE;

IMPLEMENTATION

end.
