{
   muu TrueColor library for TMT Pascal - VESA MTRR control
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

USES VBE,VBECore,VBETypes,CPUInfo,MTRR,Detect,Error;

FUNCTION locate_parameter(switch:string): boolean;
  VAR count:    byte := 0;
      parm:     string := '';

 PROCEDURE upcase_string(VAR strn:string);
  VAR cnt:  byte := 0;
   FOR cnt := 1 TO length(strn) DO
     strn[cnt] := upcase(strn[cnt]);

BEGIN
  upcase_string(switch);
  FOR count := 0 TO paramcount DO
  BEGIN
    parm := paramstr(count);
    upcase_string(parm);        
    IF (parm = switch) THEN
    BEGIN
      result := true;
      Exit;
    END ELSE
      result := false;
  END;
END;

TYPE mtrr_control = (mtrr_on,mtrr_off,mtrr_unknown);

VAR vesa:   VESAInterface := NIL;
    arg:    mtrr_control := mtrr_unknown;

begin
  writeln('VESA Linear Framebuffer Write-Combining utility');
  writeln(' Copyright (C) 2000 Tor Arne Gustad (anden@online.no)');

  IF (paramcount <> 1) THEN
    fail('usage:    vesamtrr.exe <on|off>');

  IF (NOT cpu_info.MMX) THEN
    fail('Error:  MMX capabilities required');

  IF (NOT cpu_info.MTRR) THEN
    fail('Error:  MTRR support required');

  IF (EMSVersion <> -1) THEN
    fail('Error:  EMS prohibits speed increase');

  IF (WINVersion <> -1) THEN
    fail('Error:  Cannot enable under Windows');

  new(vesa,Open);
  vesa^.getinfo;
  vesa^.getmodeinfo($100);
  IF (vesa^.error) THEN
    writeln('Error:  VESA not detected');
  IF (vesa^.modeinfo^.physbaseptr = 0) THEN
    writeln('Error:  Linear Framebuffer not supported');

  IF (locate_parameter('on') OR
      locate_parameter('true') OR
      locate_parameter('enable')) THEN
    arg := mtrr_on;

  IF (locate_parameter('off') OR
      locate_parameter('false') OR
      locate_parameter('disable')) THEN
    arg := mtrr_off;

  IF (arg = mtrr_unknown) THEN
    writeln('Error:  Unknown argument');

  IF (arg = mtrr_on) THEN
  BEGIN
    mtrr_enable(vesa^.modeinfo^.physbaseptr,
                vesa^.vesainfo^.totalmemory*65536,
                mtrr_WriteCombine);

    writeln('MTRR LFB Write-Combining enabled');
  END;

  IF (arg = mtrr_off) THEN
  BEGIN
    mtrr_disable(vesa^.modeinfo^.physbaseptr,
                 vesa^.vesainfo^.totalmemory*65536,
                 mtrr_WriteCombine);

    writeln('MTRR LFB Write-Combining disabled');
  END;

  dispose(vesa,Close);
end.
